/*
  Copyright (c) 1995, 1996 Xerox Corporation.
  All Rights Reserved.

  Use and copying of this software and preparation of derivative works
  based upon this software are permitted. Any copy of this software or
  of any derivative work must include the above copyright notice of
  Xerox Corporation, this paragraph and the one after it.  Any
  distribution of this software or derivative works must comply with all
  applicable United States export control laws.

  This software is made available AS IS, and XEROX CORPORATION DISCLAIMS
  ALL WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
  PURPOSE, AND NOTWITHSTANDING ANY OTHER PROVISION CONTAINED HEREIN, ANY
  LIABILITY FOR DAMAGES RESULTING FROM THE SOFTWARE OR ITS USE IS
  EXPRESSLY DISCLAIMED, WHETHER ARISING IN CONTRACT, TORT (INCLUDING
  NEGLIGENCE) OR STRICT LIABILITY, EVEN IF XEROX CORPORATION IS ADVISED
  OF THE POSSIBILITY OF SUCH DAMAGES.

  Author: Shigeru Chiba		chiba@parc.xerox.com
				chiba@is.s.u-tokyo.ac.jp
*/

#ifndef __metaobj_h
#define __metaobj_h

// Runtime Meta Level

extern char mBuffer[];
extern int mIndex;

/*
  MetaObj is the root class for runtime metaobjects.  The runtime
  metaobject traps member function calls on the base-level object.

  If it traps a member function call, Reflect() is invoked with the
  identifier of the member function (member), the byte array containing
  the argument list (arglist), and the length of that byte array
  (arglist_size).

  Reify() is used to actually execute a member function on the base-
  level object.
*/

class MetaObj {
public:
    virtual void Reflect(int member, char* arglist, int arglist_size);
    virtual void Reify(int member, char* arglist) = 0;
};

#endif  /* __metaobj_h */
